Index: src/wp-includes/class-wp-site.php
===================================================================
--- src/wp-includes/class-wp-site.php	(revision 37549)
+++ src/wp-includes/class-wp-site.php	(working copy)
@@ -200,6 +200,47 @@
 	}
 
 	/**
+	 * Isset-er.
+	 *
+	 * @since 4.6.0
+	 * @access public
+	 *
+	 * @param string $key Property to check if set.
+	 * @return bool
+	 */
+	public function __isset( $key ) {
+		switch ( $key ) {
+			case 'blogname':
+			case 'siteurl':
+			case 'post_count':
+			case 'home':
+				return true;
+		}
+
+		return false;
+	}
+
+	/**
+	 * Getter.
+	 *
+	 * @since 4.6.0
+	 * @access public
+	 *
+	 * @param string $key Property to get.
+	 * @return mixed
+	 */
+	public function __get( $key ) {
+		switch ( $key ) {
+			case 'blogname':
+			case 'siteurl':
+			case 'post_count':
+			case 'home':
+				$details = $this->get_details();
+				return $details->$key;
+		}
+	}
+
+	/**
 	 * Converts an object to array.
 	 *
 	 * @since 4.6.0
@@ -210,4 +251,57 @@
 	public function to_array() {
 		return get_object_vars( $this );
 	}
+
+	/**
+	 * Retrieve the details for this site.
+	 *
+	 * This method is used internally to lazy-load the extended properties of a site.
+	 *
+	 * @since 4.6.0
+	 * @access private
+	 *
+	 * @see WP_Site::__get()
+	 *
+	 * @return object A raw site object with all details included.
+	 */
+	private function get_details() {
+		$details = wp_cache_get( $this->blog_id, 'blog-details' );
+
+		if ( $details ) {
+			if ( ! is_object( $details ) ) {
+				if ( $details != -1 ) {
+					// Clear old pre-serialized objects. Cache clients do better with that.
+					wp_cache_delete( $this->blog_id, 'blog-details' );
+					unset($details);
+				}
+			} else {
+				return $details;
+			}
+		}
+
+		switch_to_blog( $this->blog_id );
+		// Create a raw copy of the object for backwards compatibility with the filter below.
+		$details = new stdClass();
+		foreach ( get_object_vars( $this ) as $key => $value ) {
+			$details->$key = $value;
+		}
+		$details->blogname   = get_option( 'blogname' );
+		$details->siteurl    = get_option( 'siteurl' );
+		$details->post_count = get_option( 'post_count' );
+		$details->home       = get_option( 'home' );
+		restore_current_blog();
+
+		/**
+		 * Filters a blog's details.
+		 *
+		 * @since MU
+		 *
+		 * @param object $details The blog details.
+		 */
+		$details = apply_filters( 'blog_details', $details );
+
+		wp_cache_set( $this->blog_id, $details, 'blog-details' );
+
+		return $details;
+	}
 }
Index: src/wp-includes/ms-blogs.php
===================================================================
--- src/wp-includes/ms-blogs.php	(revision 37549)
+++ src/wp-includes/ms-blogs.php	(working copy)
@@ -108,6 +108,8 @@
  * Retrieve the details for a blog from the blogs table and blog options.
  *
  * @since MU
+ * @since 4.6.0 Extended blog details are lazy-loaded through `WP_Site` and are available as object properties
+ *              regardless of the `$get_all` parameter.
  *
  * @global wpdb $wpdb WordPress database abstraction object.
  *
@@ -135,7 +137,8 @@
 				$blog = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM $wpdb->blogs WHERE domain = %s AND path = %s", $fields['domain'], $fields['path'] ) );
 			}
 			if ( $blog ) {
-				wp_cache_set($blog->blog_id . 'short', $blog, 'blog-details');
+				$key = md5( $blog->domain . $blog->path );
+				wp_cache_set( $key, $blog, 'blog-lookup' );
 				$blog_id = $blog->blog_id;
 			} else {
 				return false;
@@ -152,7 +155,8 @@
 				$blog = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM $wpdb->blogs WHERE domain = %s", $fields['domain'] ) );
 			}
 			if ( $blog ) {
-				wp_cache_set($blog->blog_id . 'short', $blog, 'blog-details');
+				$key = md5( $blog->domain );
+				wp_cache_set( $key, $blog, 'blog-lookup' );
 				$blog_id = $blog->blog_id;
 			} else {
 				return false;
@@ -171,84 +175,13 @@
 
 	$blog_id = (int) $blog_id;
 
-	$all = $get_all == true ? '' : 'short';
-	$details = wp_cache_get( $blog_id . $all, 'blog-details' );
-
-	if ( $details ) {
-		if ( ! is_object( $details ) ) {
-			if ( $details == -1 ) {
-				return false;
-			} else {
-				// Clear old pre-serialized objects. Cache clients do better with that.
-				wp_cache_delete( $blog_id . $all, 'blog-details' );
-				unset($details);
-			}
-		} else {
-			return $details;
-		}
-	}
-
-	// Try the other cache.
-	if ( $get_all ) {
-		$details = wp_cache_get( $blog_id . 'short', 'blog-details' );
+	if ( isset( $blog ) ) {
+		$blog = new WP_Site( $blog );
 	} else {
-		$details = wp_cache_get( $blog_id, 'blog-details' );
-		// If short was requested and full cache is set, we can return.
-		if ( $details ) {
-			if ( ! is_object( $details ) ) {
-				if ( $details == -1 ) {
-					return false;
-				} else {
-					// Clear old pre-serialized objects. Cache clients do better with that.
-					wp_cache_delete( $blog_id, 'blog-details' );
-					unset($details);
-				}
-			} else {
-				return $details;
-			}
-		}
+		$blog = WP_Site::get_instance( $blog_id );
 	}
 
-	if ( empty($details) ) {
-		$details = WP_Site::get_instance( $blog_id );
-		if ( ! $details ) {
-			// Set the full cache.
-			wp_cache_set( $blog_id, -1, 'blog-details' );
-			return false;
-		}
-	}
-
-	if ( ! $details instanceof WP_Site ) {
-		$details = new WP_Site( $details );
-	}
-
-	if ( ! $get_all ) {
-		wp_cache_set( $blog_id . $all, $details, 'blog-details' );
-		return $details;
-	}
-
-	switch_to_blog( $blog_id );
-	$details->blogname   = get_option( 'blogname' );
-	$details->siteurl    = get_option( 'siteurl' );
-	$details->post_count = get_option( 'post_count' );
-	$details->home       = get_option( 'home' );
-	restore_current_blog();
-
-	/**
-	 * Filters a blog's details.
-	 *
-	 * @since MU
-	 *
-	 * @param object $details The blog details.
-	 */
-	$details = apply_filters( 'blog_details', $details );
-
-	wp_cache_set( $blog_id . $all, $details, 'blog-details' );
-
-	$key = md5( $details->domain . $details->path );
-	wp_cache_set( $key, $details, 'blog-lookup' );
-
-	return $details;
+	return $blog;
 }
 
 /**