diff --git package-lock.json package-lock.json
index 477488d18a..68dc453454 100644
--- package-lock.json
+++ package-lock.json
@@ -6502,9 +6502,9 @@
 			}
 		},
 		"jquery": {
-			"version": "1.12.4",
-			"resolved": "https://registry.npmjs.org/jquery/-/jquery-1.12.4.tgz",
-			"integrity": "sha1-AeHfuikP5z3rp3zurLD5ui/sngw="
+			"version": "3.3.1",
+			"resolved": "https://registry.npmjs.org/jquery/-/jquery-3.3.1.tgz",
+			"integrity": "sha512-Ubldcmxp5np52/ENotGxlLe6aGMvmF4R8S6tZjsP6Knsaxd/xp3Zrh50cG93lR6nPXyUFwzN3ZSOQI0wRJNdGg=="
 		},
 		"jquery-color": {
 			"version": "github:jquery/jquery-color#95402e5b2f1184ab2de7014aeef0a90f2bee0a40",
@@ -6527,9 +6527,9 @@
 			}
 		},
 		"jquery-migrate": {
-			"version": "1.4.1",
-			"resolved": "https://registry.npmjs.org/jquery-migrate/-/jquery-migrate-1.4.1.tgz",
-			"integrity": "sha1-hRUvPsmalWJfT30Lz2LpuGOPWnY=",
+			"version": "3.0.1",
+			"resolved": "https://registry.npmjs.org/jquery-migrate/-/jquery-migrate-3.0.1.tgz",
+			"integrity": "sha512-NYlhcFnRh4Bv9jvadPlcAKQdVGRE0+TSgFYxQ+ZnCxUUHbwd+SjbOg+Xvu1Oea9mpQJ+2VB1eCfcBORWNQsHaA==",
 			"dev": true
 		},
 		"jquery-ui": {
diff --git package.json package.json
index 96aa92a301..06a4c70525 100644
--- package.json
+++ package.json
@@ -39,7 +39,7 @@
 		"grunt-sass": "2.0.0",
 		"grunt-webpack": "^3.0.2",
 		"ink-docstrap": "^1.3.0",
-		"jquery-migrate": "1.4.1",
+		"jquery-migrate": "3.0.1",
 		"matchdep": "~1.0.0",
 		"webpack": "^3.6.0",
 		"webpack-dev-server": "^2.9.1"
@@ -47,7 +47,7 @@
 	"dependencies": {
 		"backbone": "1.3.3",
 		"imagesloaded": "3.2.0",
-		"jquery": "1.12.4",
+		"jquery": "3.3.1",
 		"jquery-color": "github:jquery/jquery-color#2.1.1",
 		"jquery-form": "4.2.1",
 		"jquery-hoverintent": "1.8.3",
diff --git src/js/_enqueues/wp/customize/controls.js src/js/_enqueues/wp/customize/controls.js
index ed75ba3df1..2bebc3cbe9 100644
--- src/js/_enqueues/wp/customize/controls.js
+++ src/js/_enqueues/wp/customize/controls.js
@@ -1104,7 +1104,7 @@
 				return;
 			}
 
-			duration = ( 'resolved' === api.previewer.deferred.active.state() ? args.duration : 0 );
+			duration = ( api.previewer && 'resolved' === api.previewer.deferred.active.state() ? args.duration : 0 );
 
 			if ( construct.extended( api.Panel ) ) {
 				// If this is a panel is not currently expanded but another panel is expanded, do not animate.
diff --git src/js/_enqueues/wp/customize/widgets.js src/js/_enqueues/wp/customize/widgets.js
index 40b514876b..13e0c33f24 100644
--- src/js/_enqueues/wp/customize/widgets.js
+++ src/js/_enqueues/wp/customize/widgets.js
@@ -1688,7 +1688,7 @@
 					noticeContainer.toggle( shouldShowNotice() );
 				});
 				api.bind( 'pane-contents-reflowed', function() {
-					var duration = ( 'resolved' === api.previewer.deferred.active.state() ) ? 'fast' : 0;
+					var duration = ( api.previewer && 'resolved' === api.previewer.deferred.active.state() ) ? 'fast' : 0;
 					updateNotice();
 					if ( shouldShowNotice() ) {
 						noticeContainer.slideDown( duration );
diff --git tests/qunit/wp-admin/js/customize-controls.js tests/qunit/wp-admin/js/customize-controls.js
index 47ab5c0203..57558f4942 100644
--- tests/qunit/wp-admin/js/customize-controls.js
+++ tests/qunit/wp-admin/js/customize-controls.js
@@ -6,7 +6,7 @@ wp.customize.settingConstructor.abbreviation = wp.customize.Setting.extend({
 	}
 });
 
-jQuery( window ).load( function (){
+jQuery( document ).ready( function (){
 	'use strict';
 
 	var controlId, controlLabel, controlType, controlContent, controlDescription, controlData, mockControl,
diff --git tests/qunit/wp-admin/js/customize-nav-menus.js tests/qunit/wp-admin/js/customize-nav-menus.js
index 3ac6da8662..04b5126918 100644
--- tests/qunit/wp-admin/js/customize-nav-menus.js
+++ tests/qunit/wp-admin/js/customize-nav-menus.js
@@ -1,5 +1,5 @@
 /* global wp */
-jQuery( window ).load( function (){
+jQuery( document ).ready( function (){
 
 	var api = wp.customize,
 		primaryMenuId = 3,
diff --git tests/qunit/wp-admin/js/customize-widgets.js tests/qunit/wp-admin/js/customize-widgets.js
index 5f754a497a..416b7b9234 100644
--- tests/qunit/wp-admin/js/customize-widgets.js
+++ tests/qunit/wp-admin/js/customize-widgets.js
@@ -1,5 +1,5 @@
 /* global wp */
-jQuery( window ).load( function() {
+jQuery( document ).ready( function() {
 
 	var api = wp.customize, $ = jQuery;
 